          section   main

          include   flp1_wman_keys
          include   flp1_wman_wwork
          include   flp1_wman_wstatus
          include   flp1_qdos_io
          include   flp1_qdos_pt
          include   flp1_qdos1_inc
          include   flp1_qdos2_inc
          include   flp1_qdos3_inc
          include   flp1_macro_inc
          include   flp1_config_mac
*
          xref.s    wst_digital
          xref.s    wst_button
          xref.l    wwa.digital
          xref.l    wwb.button
          xref      men_digital
          xref      men_button
          xref      set_up
          xdef      qtp_ink1
          xdef      qtp_ink2
          xdef      wsav,wsav0
*
dv_chid   equ       -4
dv_wmvec  equ       -8
dv_wwork  equ       -12
dv_trans  equ       -20
dv_dwind  equ       -24
dv_ddata  equ       -28
dv_butpos equ       -32
dv_winpos equ       -36
dv_end    equ       $30
*
*         Job header etc.
*
          job       {'digiCLOCK'}
*
          lea       dv_end(a6,a4.l),a6            ; data area
          move.l    a6,a4
main_clr  clr.l     (a4)+                         ; clear all data
          cmp.l     a4,sp                         ; bottom of stack?
          bgt.s     main_clr
*
          move.l    qtp_xbut,d1                   ; preset button pos.
          add.l     men_button+4,d1
          move.l    d1,dv_butpos(a6)
          move.l    qtp_xorg,d1                   ; preset window pos.
          add.l     men_digital+4,d1
          move.l    d1,dv_winpos(a6)
*
          lea       condef,a0                     ; console device
          moveq     #-1,d1                        ; for myself
          moveq     #2,d3                         ; exclusive
          qdosoc    io.open                       ; open it now
          tst.l     d0
          bne       main_kill                     ; ooops
          move.l    a0,dv_chid(a6)                ; keep channel ID
*
          moveq     #-1,d3
          qdosio    iop.pinf                      ; get pointer info
          tst.l     d0
          bne       noptr                         ; ooops
          cmpi.w    #'14',d1                      ; new pointer?
          bcs       oldptr                        ; ooops
          move.l    a1,d1                         ; WMAN vector?
          beq       nowman                        ; ooops
          move.l    d1,dv_wmvec(a6)               ; keep vector
          cmpi.w    #'08',2(a1)                   ; new WMAN?
          bcs       oldptr                        ; ooops
*
          qdosmt    mt.inf                        ; get SysVars
          btst      #3,sv_mcsta(a0)               ; test MODE
          beq.s     main_mode                     ; is MODE 4
          moveq     #0,d1
          moveq     #0,d2
          qdosmt    mt.dmode                      ; set MODE 4
*
main_mode
          move.b    qtp_set,d1
          beq       start_but
main_cont
          moveq     #$7f,d2                       ; set priority
          bsr       setprio
          move.l    dv_chid(a6),a0                ; channel ID
          lea       wst_digital(a6),a1            ; status area
          move.l    dv_wmvec(a6),a2               ; WMAN vector
          lea       men_digital,a3                ; window definition
          moveq     #0,d1                         ; default size
          bsr       dsu_fset                      ; do first setup
          bne.s     main_kill                     ; ooops
*
          move.l    dv_winpos(a6),d1              ; pointer position
          jsr       wm.prpos(a2)                  ; position primary
          bne.s     main_kill                     ; ooops
*
          jsr       wm.wdraw(a2)                  ; draw window
          bne.s     main_kill                     ; ooops
          bsr       set_up                        ; create CLOCK job
          bne.s     main_kill
          movem.l   a0/a1,-(sp)
          suba.l    a1,a1
          moveq     #-1,d1
          moveq     #5,d3
          qdosmt    mt.susjb
          movem.l   (sp)+,a0/a1
          bsr.s     wsav
main_rptr
          jsr       wm.rptr(a2)                   ; read pointer
          bne.s     main_kill                     ; ooops
          btst      #pt..zzzz,wsp_weve(a1)        ; SLEEP?
          bne       set_butt
          btst      #pt..can,wsp_weve(a1)         ; QUIT?
          beq.s     main_rptr
          bra.s     main_kill
*
kill_disp
          move.l    a1,-(sp)
          move.l    dv_chid(a6),a0                ; close main channel
          qdosoc    io.close
          qdosmt    mt.inf                        ; get SysVars
          move.l    sv_jbbas(a0),a0               ; first job
          move.l    (a0),a0
          lea       $68(a0),a0                    ; BV_BASE
          move.l    bv_comch(a0),a0               ; command chan ID
          move.l    (sp)+,a1
          vector    ut.mtext,a2                   ; print message
*
main_kill
          moveq     #0,d3
          moveq     #-1,d1
          qdosmt    mt.frjob                      ; kill this job
*
setprio   moveq     #-1,d1
          qdosmt    mt.prior
nowsav    rts
*
noptr     lea       nptr,a1
          bra.s     kill_disp
nowman    lea       nwman,a1
          bra.s     kill_disp
oldptr    lea       optr,a1
          bra.s     kill_disp
*
wsav      move.b    qtp_mod,d1
          beq.s     nowsav
wsav0     movem.l   a0/a1,-(sp)
          qdosmt    mt.inf
          move.l    sv_chbas(a0),a0
          move.w    2(sp),d1
          lsl.w     #2,d1
          move.l    (a0,d1.w),a0
wsav1     tst.b     ch_stat(a0)
          bne       wsav1
*
          move.l    (sp)+,a0
          move.l    (a4),a1
          move.w    ws_citem(a1),d2
          bmi.s     wsav2
          bset      #7,ws_citem(a1)
          jsr       wm.drbdr(a2)
*
wsav2     suba.l    a1,a1
          moveq     #0,d1
          moveq     #-1,d3
          qdosio    iop.wsav
          tst.w     d2
          bmi.s     wsav3
          move.l    (a4),a1
          move.w    ws_cipap(a1),d1
          move.w    #7,ws_cipap(a1)
          jsr       wm.drbdr(a2)
          move.w    d1,ws_cipap(a1)
          bclr      #7,ws_citem(a1)
wsav3     move.l    (sp)+,a1
          rts
*
*         Routine to change window to BUTTON
*
set_butt  moveq     #-1,d1                        ; remove CLOCK job
          moveq     #0,d2
          qdosmt    mt.jinf
          moveq     #0,d3
          qdosmt    mt.frjob
          move.l    ww_xorg(a4),d1                ; store window pos.
          add.l     men_digital+4,d1
          move.l    d1,dv_winpos(a6)
          bsr.s     unset
          move.l    dv_dwind(a6),a0               ; close daughter's window
          qdosoc    io.close
start_but
          clr.l     dv_dwind(a6)
          moveq     #1,d2                         ; set priority low
          bsr       setprio
*
          move.l    dv_chid(a6),a0                ; channel ID
          lea       wst_button(a6),a1             ; status area
          move.l    dv_wmvec(a6),a2               ; WMAN vector
          lea       men_button,a3                 ; window definition
          moveq     #0,d1                         ; default size
          bsr.s     bsu_fset                      ; do first setup
          bne       main_kill                     ; ooops
*
          move.l    dv_butpos(a6),d1              ; pointer pos.
          jsr       wm.prpos(a2)                  ; position primary
          bne       main_kill                     ; ooops
*
          jsr       wm.wdraw(a2)                  ; draw window
          bne       main_kill                     ; ooops
          bsr       wsav0
*
butt_rptr
          jsr       wm.rptr(a2)                   ; read pointer
          bne       main_kill                     ; ooops
          btst      #pt..zzzz,wsp_weve(a1)        ; SLEEP?
          bne.s     kill_butt
          btst      #pt..can,wsp_weve(a1)         ; QUIT?
          beq.s     butt_rptr
          bra       main_kill
*
*         Routine to return to FULL window
*
kill_butt move.l    ww_xorg(a4),d1                ; store this pos.
          add.l     men_button+4,d1
          move.l    d1,dv_butpos(a6)
          bsr.s     unset
          bra       main_cont
*
unset     move.l    dv_wmvec(a6),a2               ; unset main window
          moveq     #-1,d1
          jsr       wm.unset(a2)
          move.l    a4,a0                         ; kill heap
          qdosmt    mt.rechp
          rts
*
lsztab    dc.l      wwa.digital
zzztab    dc.l      wwb.button
bsu_fset  movem.l   d1-d3/a0-a3,-(sp)             ; allocate heap
          move.l    zzztab,d1                     ; and do SETUP
          bra.s     dsu_doit
dsu_fset  movem.l   d1-d3/a0-a3,-(sp)             ; allocate heap
          move.l    lsztab,d1                     ; and do a SETUP
dsu_doit  moveq     #-1,d2
          qdosmt    mt.alchp
          move.l    a0,a4
          movem.l   (sp)+,d1-d3/a0-a3
          tst.l     d0
          bne.s     dsu_exit                      ; ooops
          move.l    a4,dv_wwork(a6)
          jsr       wm.setup(a2)
dsu_exit  rts
*
*         CONFIG Block
*
X         equ       wsi.slct
*
          mkcfhead  digiCLOCK,1.02
*
          mkcfitem  select,'B',qtp_set,,,{Start-up status}\
                    0,,{Window},1,,{Button}
          mkcfitem  select,'M',qtp_mod,,,{MODE guardian}\
                    0,,{On},1,,{Off}
          mkcfitem  byte,'T',qtp_ink1,,,{colour for TIME display}
          mkcfitem  byte,'D',qtp_ink2,,,{colour for DATE display}
          mkcfitem  word,'X',qtp_xorg,,,{X-origin of window},0,358
          mkcfitem  word,'Y',qtp_yorg,,,{Y-origin of window},0,187
          mkcfitem  word,'x',qtp_xbut,,,{X-origin of button},0,471
          mkcfitem  word,'y',qtp_ybut,,,{Y-origin of button},0,242
*
          mkcfend
*
qtp_mod   dc.b      0,X
qtp_set   dc.b      X,0
qtp_ink1  dc.b      $60
qtp_ink2  dc.b      7
qtp_xorg  dc.w      358
qtp_yorg  dc.w      0
qtp_xbut  dc.w      10
qtp_ybut  dc.w      5
*
nptr      string    {'Pointer Interface not present',10}
nwman     string    {'Window Manager not present',10}
optr      string    {'Pointer Environment too old',10}
*
condef    string    {'CON_2x1a0x0'}
          dc.w      0
*
          end
