          section   MAIN

mt.cjob   equ       $1
mt.jinf   equ       $2
mt.susjb  equ       $8
mt.activ  equ       $a
mt.prior  equ       $b
mt.rclck  equ       $13
io.open   equ       $1
io.sstrg  equ       $7
sd.wdef   equ       $d
sd.pos    equ       $10
sd.pixp   equ       $17
sd.clear  equ       $20
sd.setin  equ       $29
sd.setsz  equ       $2d
ut.mtext  equ       $d0
cn.date   equ       $ec

dv_trans  equ       -20
dv_dwind  equ       -24
dv_ddata  equ       -28

          xdef      set_up
          xdef      redefine
          xref      qtp_ink1
          xref      qtp_ink2
*
*         Routine to create CLOCK daughter job
*

set_up    movem.l   a0-a4,-(sp)                   ; store regs
          moveq     #-1,d1                        ; my job
          moveq     #0,d2                         ; no code length
          moveq     #$7e,d3                       ; data space
          lea       job_start,a1                  ; start address
          moveq     #mt.cjob,d0                   ; create job
          trap      #1
          tst.l     d0
          bne.s     set_error
          movem.l   a0/d1,-(sp)
          moveq     #-1,d1
          moveq     #1,d3
          lea       wind,a0
          moveq     #io.open,d0                   ; open secondary
          trap      #2
          movem.l   (sp)+,a1/d4
          move.l    a0,(a1)
          move.l    a0,dv_dwind(a6)               ; store channel ID
          move.l    a1,dv_ddata(a6)
          move.l    4(sp),a1
          bsr.s     redefine
          moveq     #-1,d3
          moveq     #sd.clear,d0                  ; clear window
          trap      #3
          move.l    d4,d1
          moveq     #1,d2                         ; lowest priority
          moveq     #0,d3                         ; timeout
          moveq     #mt.activ,d0                  ; activate it
          trap      #1
set_error movem.l   (sp)+,a0-a4                   ; restore regs
          tst.l     d0                            ; errors?
          rts

wind      dc.b      0,4,'SCR_'

*
*         Routine to set real definition of window
*

redefine  tst.l     dv_dwind(a6)
          beq.s     redefex
          movem.l   d1-d3/a0/a1/a3,-(sp)
          move.l    (a1),a1                       ; transfer old defn.
          lea       dv_trans(a6),a3
          move.l    dv_dwind(a6),a0
          move.l    $20(a1),(a3)
          move.l    $24(a1),4(a3)
          sub.l     #$c0018,(a3)
          add.l     #$60014,4(a3)
          moveq     #7,d1
          moveq     #1,d2
          moveq     #-1,d3
          move.l    a3,a1
          moveq     #sd.wdef,d0                   ; redefine window
          trap      #3
          move.l    dv_ddata(a6),a1
          clr.l     4(a1)
          sf        8(a6)
          movem.l   (sp)+,d1-d3/a0/a1/a3
redefex   rts

*
*         Body of CLOCK display job
*

job_start add.l     a4,a6                         ; dataspace address
          moveq     #-1,d1
          moveq     #0,d2
          moveq     #mt.jinf,d0                   ; get main job ID
          trap      #1
          move.l    d2,d7
          clr.l     4(a6)
          sf        8(a6)
          bra       jobentry
jobloop   move.l    d1,4(a6)
          move.l    a6,-(sp)
          movem.l   $30(a6),d5/d6                 ; remember old date
          lea       $40(a6),a1
          suba.l    a6,a6
          move.w    cn.date,a2                    ; convert time
          jsr       (a2)
          move.l    (sp)+,a6
          cmp.l     $30(a6),d5                    ; changed date?
          bne.s     jobflag
          cmp.l     $34(a6),d6
          beq.s     jobprio
jobflag   sf        8(a6)                         ; clear flag
jobprio   move.l    d7,d1                         ; freeze main job
          moveq     #0,d2
          moveq     #mt.prior,d0
          trap      #1
          move.l    (a6),a0
          moveq     #2,d1
          moveq     #2,d2
          moveq     #-1,d3
          moveq     #sd.pixp,d0                   ; position cursor
          trap      #3
          move.b    qtp_ink1,d1
          moveq     #sd.setin,d0                  ; set INK
          trap      #3
          moveq     #3,d1
          moveq     #1,d2
          moveq     #sd.setsz,d0                  ; set CSIZE
          trap      #3
          lea       $38(a6),a1
          moveq     #8,d2
          moveq     #io.sstrg,d0                  ; print string
          trap      #3
          tst.b     $8(a6)                        ; flag to skip?
          bne.s     jobskip
jobdate   st        $8(a6)                        ; set flag
          moveq     #0,d1
          moveq     #0,d2
          moveq     #sd.pos,d0                    ; position cursor
          trap      #3
          moveq     #1,d1
          moveq     #0,d2
          moveq     #sd.setsz,d0                  ; set CSIZE
          trap      #3
          moveq     #22,d1
          moveq     #26,d2
          moveq     #sd.pixp,d0                   ; position cursor
          trap      #3
          move.b    qtp_ink2,d1
          moveq     #sd.setin,d0                  ; set INK
          trap      #3
          lea       $2c(a6),a1
          moveq     #11,d2
          moveq     #io.sstrg,d0                  ; print string
          trap      #3
jobskip   move.l    d7,d1
          moveq     #$7f,d2
          moveq     #mt.prior,d0                  ; reset priority
          trap      #1
susloop   moveq     #-1,d1
          moveq     #10,d3
          suba.l    a1,a1
          moveq     #mt.susjb,d0                  ; freeze this one
          trap      #1
jobentry  moveq     #mt.rclck,d0                  ; read clock
          trap      #1
          cmp.l     4(a6),d1
          beq.s     susloop
          bra       jobloop

          end
