          include   flp1_qdos1_inc
          include   flp1_qdos2_inc
          include   flp1_wman_keys
          include   flp1_wman_wwork
          include   flp1_wman_wstatus
          include   flp1_qdos_pt

          section   MAIN

          xdef      setup,setdata,setprog,setdest,setpuse,setpdev
          xdef      nfsuse,nfsset,devset,setstat,setuser
          xref.s    mv_device
          xref.s    mv_data
          xref.s    mv_prog
          xref.s    mv_dest
          xref.s    mv_prt
          xref.s    mv_prtin
          xref.s    mv_prtout
          xref.s    mv_netstat
          xref.s    mv_user
          xref.s    mv_netptr,mv_netuse
          xref.s    mv_net1,mv_net2,mv_net3,mv_net4
          xref      met_none
          xref      qtp_auto

*
*         MAIN SETUP routine
*

SETUP     bsr.s     sstan
          bsr       sprt
          bsr       snetn
          bsr       suser
          bsr       snets
          bsr       sdevs
          moveq     #-1,d3
          jsr       wm.ldraw(a2)                  ; redraw items
          rts

*
*         Subroutine to get standard devices
*

SSTAN     movem.l   a0-a5,-(sp)                   ; store registers
          move.l    ww_plitm(a4),a2               ; ptr to loose menu items
          lea       110(a2),a2                    ; start of standard devs.
          lea       met_none,a3                   ; 'NONE' string
          moveq     #2,d0
sslop1    move.b    #$11,ws_litem+5(a1,d0.w)      ; set to unavailable
          move.w    d0,d5
          mulu      #wwl.elen,d5
          move.l    a3,wwl_pobj(a2,d5.w)          ; set text to 'NONE'
          dbf       d0,sslop1
          moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          moveq     #0,d5                         ; counter
          move.l    sv_data(a0),d1                ; get ptr. to DATAD$
          beq.s     ssdev1                        ; next one
          lea       mv_data(a6),a4                ; space for string
          bsr.s     sssub
ssdev1    addq.w    #1,d5                         ; counter
          move.l    sv_prog(a0),d1                ; get ptr. to PROGD$
          beq.s     ssdev2                        ; next one
          lea       mv_prog(a6),a4                ; space for string
          bsr.s     sssub
ssdev2    addq.w    #1,d5                         ; counter
          move.l    sv_dest(a0),d1                ; get ptr. to DESTD$
          beq.s     ssdev3                        ; exit
          lea       mv_dest(a6),a4                ; space for string
          bsr.s     sssub
ssdev3    andi.w    #$dfff,sr
          movem.l   (sp)+,a0-a5                   ; restore registers
          rts
*
sssub     move.b    #1,ws_litem+5(a1,d5.w)        ; set to available
          move.l    d1,a5                         ; pointer to device
          move.w    (a5)+,d1                      ; get length
          beq.s     sssrts
          move.w    d5,d2
          mulu      #wwl.elen,d2
          move.l    a4,wwl_pobj(a2,d2.w)          ; set object pointer
          cmpi.w    #30,d1                        ; too long?
          bcs.s     sssub1
          moveq     #29,d1
sssub1    move.w    d1,(a4)+                      ; store length
          bra.s     sssub3
sssub2    move.b    (a5)+,(a4)+                   ; move string
sssub3    dbf       d1,sssub2
sssrts    rts

*
*         Subroutine to get PRT devices
*

SPRT      movem.l   a0-a5,-(sp)                   ; store registers
          move.l    ww_plitm(a4),a2               ; ptr to loose menu items
          lea       176(a2),a2                    ; start of PRT devices
          lea       met_none,a3                   ; get 'NONE' string
          move.b    #$11,ws_litem+4(a1)           ; set ABORT unavailable
          move.w    #$1111,ws_litem+8(a1)         ; set both unavailable
          move.w    #wwl.elen,d5
          move.l    a3,wwl_pobj(a2)               ; set to NONE object
          move.l    a3,wwl_pobj(a2,d5.w)
          clr.l     mv_prt(a6)                    ; clear pointers
          clr.l     mv_prt+4(a6)
          moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          move.l    sv_drlst(a0),a0               ; DR drivers
sprt1     cmpi.l    #'PRT%',$26(a0)               ; is it PRT?
          beq.s     sprt2
          move.l    (a0),d1                       ; get next pointer
          beq.s     sprtend
          move.l    d1,a0
          bra.s     sprt1
sprt2     move.b    #1,ws_litem+4(a1)             ; set ABORT available
          lea       mv_prtin(a6),a4               ; space for string
          lea       $3e(a0),a5                    ; pointer to driver
          moveq     #0,d5                         ; counter
          bsr.s     sprtsub
          lea       mv_prtout(a6),a4              ; space for string
          lea       $4a(a0),a5                    ; pointer to driver
          moveq     #1,d5                         ; counter
          bsr.s     sprtsub
          move.l    $5c(a0),mv_prt+4(a6)          ; store ABORT pointer
          move.l    a0,mv_prt(a6)                 ; store driver start
sprtend   andi.w    #$dfff,sr
          movem.l   (sp)+,a0-a5                   ; restore registers
          rts

sprtsub   move.b    #1,ws_litem+8(a1,d5.w)        ; set to available
          move.w    (a5)+,d1                      ; get length
          beq.s     sprtrts
          mulu      #wwl.elen,d5
          move.l    a4,wwl_pobj(a2,d5.w)          ; set object pointer
          cmpi.w    #9,d1                         ; too long?
          bcs.s     sprtsb1
          moveq     #8,d1
sprtsb1   move.w    d1,(a4)+                      ; store length
          bra.s     sprtsb3
sprtsb2   move.b    (a5)+,(a4)+                   ; move string
sprtsb3   dbf       d1,sprtsb2
sprtrts   rts

*
*         Subroutine to get NET station number
*

SNETN     movem.l   a0-a3,-(sp)                   ; store registers
          move.l    ww_plitm(a4),a2               ; ptr to loose menu items
          lea       220(a2),a2                    ; start of NET station
          moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          move.b    sv_netnr(a0),d1               ; get NET station
          beq.s     snetn2
          cmpi.b    #$8,d1                        ; extract number
          bcc.s     snetn1
          andi.w    #$7,d1
          bra.s     snetn3
snetn1    andi.w    #$8,d1
          bra.s     snetn3
snetn2    moveq     #1,d1
snetn3    move.b    d1,sv_netnr(a0)               ; correct old entry
          move.b    #1,ws_litem+10(a1)            ; set item available
          lea       mv_netstat(a6),a1
          move.w    #1,(a1)                       ; set length
          add.b     #$30,d1
          move.b    d1,2(a1)                      ; set number
          move.l    a1,wwl_pobj(a2)               ; set object
          andi.w    #$dfff,sr
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts

*
*         Subroutine to get USER number
*

SUSER     movem.l   a0-a3,-(sp)                   ; store registers
          move.l    ww_plitm(a4),a2               ; ptr to loose menu items
          lea       242(a2),a2                    ; start of USER number
          move.b    #$11,ws_litem+11(a1)          ; set to unavailable
          clr.l     wwl_pobj(a2)                  ; clear string
          moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          move.l    sv_qtk3(a0),d1                ; TK3 present?
          beq.s     suserend
          move.l    d1,a3
          cmpi.l    #'QTK3',(a3)
          bne.s     suserend
          lea       mv_user(a6),a3                ; ptr to string
          move.b    #1,ws_litem+11(a1)            ; set to available
          move.b    sv_user(a0),d1                ; get user number
          andi.w    #$f,d1                        ; mask it
          move.b    d1,sv_user(a0)                ; update entry
          cmpi.b    #10,d1                        ; lower than 10?
          bcc.s     suser1                        ; no
          move.w    #1,(a3)                       ; set length
          add.b     #$30,d1
          move.b    d1,2(a3)                      ; set number
          bra.s     suser2
suser1    move.w    #2,(a3)                       ; set length
          move.b    #'1',2(a3)                    ; set '1'
          add.b     #$26,d1
          move.b    d1,3(a3)                      ; set low number
suser2    move.l    a3,wwl_pobj(a2)               ; set object
suserend  andi.w    #$dfff,sr
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts

*
*         Subroutine to get NFS devices
*

SNETS     movem.l   a0-a5,-(sp)                   ; store registers
          move.l    ww_plitm(a4),a2               ; ptr to loose menu items
          lea       264(a2),a2                    ; start of NFS devices
          move.l    #$11111111,ws_litem+12(a1)    ; set to unavailable
          move.b    #$11,ws_litem+16(a1)
          clr.l     wwl_pobj(a2)                  ; clear object
          lea       met_none,a3                   ; get 'NONE' string
          moveq     #0,d5
          moveq     #3,d1
snets0    add.w     #wwl.elen,d5
          move.l    a3,wwl_pobj(a2,d5.w)          ; set objects to 'NONE'
          dbf       d1,snets0
          moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          move.l    sv_ddlst(a0),a0               ; get DD drivers
snets1    cmpi.l    #$14e20,$24(a0)               ; look for 'N' driver
          beq.s     snets2
          move.l    (a0),d1                       ; next driver
          beq.s     snetsend
          move.l    d1,a0
          bra.s     snets1
snets2    move.l    #$1010101,ws_litem+12(a1)     ; set all to available
          move.b    #1,ws_litem+16(a1)
          lea       $5a(a0),a5                    ; get USAGE string
          move.w    (a5)+,d1                      ; get length
          beq.s     snets3
          cmpi.w    #3,d1                         ; length 3 ?
          bcc.s     snets22
          moveq     #0,d1                         ; set to 0
          bra.s     snets3
snets22   moveq     #3,d1
snets3    move.w    d1,$5a(a0)
          lea       mv_netuse(a6),a4              ; space for string
          move.w    d1,(a4)                       ; store length
          move.l    (a5),2(a4)                    ; store name
          move.l    a4,wwl_pobj(a2)               ; set object
          lea       $60(a0),a5                    ; NFS #1
          lea       mv_net1(a6),a4                ; space for string
          moveq     #1,d5                         ; counter
          bsr.s     snsub
          lea       $70(a0),a5                    ; NFS #2
          lea       mv_net2(a6),a4                ; space for string
          addq.w    #1,d5                         ; counter
          bsr.s     snsub
          lea       $80(a0),a5                    ; NFS #3
          lea       mv_net3(a6),a4                ; space for string
          addq.w    #1,d5                         ; counter
          bsr.s     snsub
          lea       $90(a0),a5                    ; NFS #4
          lea       mv_net4(a6),a4                ; space for string
          addq.w    #1,d5                         ; counter
          bsr.s     snsub
          move.l    a0,mv_netptr(a6)              ; store ptr to driver
snetsend  andi.w    #$dfff,sr
          movem.l   (sp)+,a0-a5                   ; restore registers
          rts

snsub     move.b    #1,ws_litem+12(a1,d5.w)       ; set to available
          tst.w     2(a5)                         ; test length
          beq.s     snsrts
          move.w    d5,d2
          mulu      #wwl.elen,d2
          move.l    a4,wwl_pobj(a2,d2.w)          ; set object pointer
          move.w    #3,(a4)+                      ; preset length
          move.b    #'N',(a4)+                    ; preset 'N'
          move.w    (a5)+,d2                      ; get number
          add.b     #$30,d2                       ; make it ASCII
          move.b    d2,(a4)+                      ; and store it
          move.b    #'_',(a4)+                    ; preset underscore
          move.w    (a5)+,d1                      ; get length
          cmpi.w    #13,d1                        ; too long?
          bcs.s     snsub1
          moveq     #12,d1
snsub1    add.w     d1,-5(a4)                     ; add length
          bra.s     snsub3
snsub2    move.b    (a5)+,(a4)+                   ; move string
snsub3    dbf       d1,snsub2
snsrts    rts

*
*         Subroutine to get devices
*

SDEVS     movem.l   a0-a3,-(sp)                   ; store registers
          move.l    ww_plitm(a4),a2               ; ptr to loose menu items
          lea       374(a2),a2                    ; start of devices
          lea       mv_device(a6),a0              ; string addresses
          moveq     #5,d0
sdlop1    move.b    #$11,ws_litem+17(a1,d0.w)     ; set to unavailable
          move.w    d0,d5
          mulu      #wwl.elen,d5
          clr.l     wwl_pobj(a2,d5.w)             ; clear object
          clr.l     (a0)+                         ; clear pointer
          clr.l     (a0)+                         ; clear string
          clr.w     (a0)+
          dbf       d0,sdlop1
          moveq     #0,d7                         ; start with counter 0
          moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          move.l    sv_ddlst(a0),a0               ; DD drivers
sdlop2    cmpi.w    #6,d7                         ; table full?
          bcc.s     sdend
          move.w    $24(a0),d1                    ; name length
          beq.s     sdnext
          cmpi.w    #3,d1                         ; too long?
          bne.s     sdnext
          move.w    d7,d2
          mulu      #10,d2                        ; offset in table
          lea       mv_device(a6),a3
          add.w     d2,a3
          move.l    a0,(a3)                       ; store driver
          move.w    d1,4(a3)                      ; store length
          move.l    $26(a0),6(a3)                 ; store name
          move.b    #1,ws_litem+17(a1,d7.w)       ; set available
          move.w    d7,d2
          mulu      #wwl.elen,d2
          addq.l    #4,a3
          move.l    a3,wwl_pobj(a2,d2.w)          ; set object
          addq.w    #1,d7                         ; increment counter
sdnext    move.l    (a0),a0                       ; get next pointer
          move.l    a0,d1
          bne.s     sdlop2
sdend     andi.w    #$dfff,sr
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts

*
*         Subroutine to edit an item
*

WMEDIT    moveq     #0,d2
          jsr       wm.swlit(a2)                  ; set sub_window
          move.l    a3,a1
          jmp       wm.ename(a2)                  ; edit name

*
*         Routine to set DATAD$
*

SETDATA   movem.l   d1/d2/d4/d7/a0-a3,-(sp)       ; store registers
          moveq     #5,d1                         ; item #5
          lea       mv_data(a6),a3                ; get string
          move.w    #sv_data,d7
          move.b    qtp_auto,d2                   ; autocopy engaged?
          beq.s     setpro0
          bsr       wmedit                        ; edit string
          move.w    (a1),d4
          beq.s     setdat1
          cmpi.w    #29,d4                        ; buffer full?
          bcc.s     setdat1
          cmpi.b    #'_',1(a1,d4.w)               ; underscore present?
          beq.s     setdat1
          addq.w    #1,d4
          move.w    d4,(a1)
          move.b    #'_',1(a1,d4.w)
setdat1   moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          move.l    (a0,d7.w),d1
          beq.s     setdatx
          move.l    sv_prog(a0),d2
          beq.s     setdatx
          move.l    d1,a0
          move.l    d2,a2
          move.w    d4,(a0)+                      ; store length
          move.w    d4,(a2)+
          addq.l    #2,a1
          bra.s     setdat3
setdat2   move.b    (a1),(a0)+                    ; copy string
          move.b    (a1)+,(a2)+
setdat3   dbf       d4,setdat2
setdatx   andi.w    #$dfff,sr
          movem.l   (sp)+,d1/d2/d4/d7/a0-a3
          bra       sstan

*
*         Routine to set PROGD$
*

SETPROG   movem.l   d1/d2/d4/d7/a0-a3,-(sp)       ; store registers
          moveq     #6,d1                         ; item #6
          lea       mv_prog(a6),a3                ; get string
          move.w    #sv_prog,d7
setpro0   bsr       wmedit                        ; edit string
          move.w    (a1),d4
          beq.s     setpro1
          cmpi.w    #29,d4                        ; buffer full?
          bcc.s     setpro1
          cmpi.b    #'_',1(a1,d4.w)               ; underscore present?
          beq.s     setpro1
          addq.w    #1,d4
          move.w    d4,(a1)
          move.b    #'_',1(a1,d4.w)
setpro1   moveq     #0,d0
          trap      #1                            ; get SysVars
          trap      #0
          move.l    (a0,d7.w),d1
          beq.s     setprox
          move.l    d1,a0
          move.w    d4,(a0)+                      ; store length
          addq.l    #2,a1
          bra.s     setpro3
setpro2   move.b    (a1)+,(a0)+                   ; copy string
setpro3   dbf       d4,setpro2
setprox   andi.w    #$dfff,sr
          movem.l   (sp)+,d1/d2/d4/d7/a0-a3
          bra       sstan

*
*         Routine to set DESTD$
*

SETDEST   movem.l   d1/d2/d4/d7/a0-a3,-(sp)       ; store registers
          moveq     #7,d1                         ; item #7
          lea       mv_dest(a6),a3                ; get string
          bsr       wmedit                        ; edit string
          move.w    #sv_dest,d7
          move.w    (a1),d4
          bra       setpro1

*
*         Routine to set PRT Usage
*

SETPUSE   movem.l   d1/d2/d4/a0-a3,-(sp)          ; store registers
          moveq     #8,d1                         ; item #8
          lea       mv_prtin(a6),a3               ; get string
          bsr       wmedit                        ; edit string
          move.l    mv_prt(a6),a2                 ; get driver address
          lea       $3e(a2),a2                    ; address for item
setpus1   trap      #0
          move.w    (a1)+,d4                      ; get length
          move.w    d4,(a2)+                      ; store length
          bra.s     setpus3
setpus2   move.b    (a1)+,(a2)+                   ; copy string
setpus3   dbf       d4,setpus2
          andi.w    #$dfff,sr
          movem.l   (sp)+,d1/d2/d4/a0-a3
          bra       sprt

*
*         Routine to set PRT Device
*

SETPDEV   movem.l   d1/d2/d4/a0-a3,-(sp)          ; store registers
          moveq     #9,d1                         ; item #9
          lea       mv_prtout(a6),a3              ; get string
          bsr       wmedit                        ; edit string
          move.l    mv_prt(a6),a2                 ; get driver address
          lea       $4a(a2),a2                    ; address for item
          bra       setpus1

*
*         Routine to set NFS Usage
*

NFSUSE    movem.l   d1/d2/d4/a0-a3,-(sp)          ; store registers
nfsuse0   moveq     #12,d1                        ; item #12
          lea       mv_netuse(a6),a3              ; get string
          bsr       wmedit                        ; edit string
          move.w    (a1),d1                       ; check length
          beq.s     nfsuse2
          cmpi.w    #3,d1
          bne.s     nfsuse0
          bra.s     nfsuse2
nfsuse1   move.b    2(a1,d1.w),d2                 ; validation check
          cmpi.b    #'A',d2
          bcs.s     nfsuse0
          cmpi.b    #$7b,d2
          bcc.s     nfsuse0
          cmpi.b    #$5b,d2
          bcs.s     nfsuse2
          cmpi.b    #'a',d2
          bcs.s     nfsuse0
nfsuse2   dbf       d1,nfsuse1
          move.l    mv_netptr(a6),a2              ; get driver address
          lea       $5a(a2),a2                    ; address for item
nfsuse3   trap      #0
          move.w    (a1)+,(a2)+                   ; copy length
          and.l     #$dfdfdfdf,(a1)               ; upper case
          move.l    (a1),(a2)                     ; copy string
          andi.w    #$dfff,sr
          movem.l   (sp)+,d1/d2/d4/a0-a3
          bsr       snets
          bra       sdevs

*
*         Routine to set NFS devices
*

NFSSET    movem.l   d1/d2/d4/a0-a3,-(sp)          ; store registers
          move.w    d7,d1                         ; item number
          sub.w     #13,d1                        ; calc buffer
          mulu      #18,d1
          add.w     #mv_net1,d1
          lea       (a6,d1.w),a3                  ; string address
          tst.w     (a3)
          bne.s     nfsset0
          move.w    #3,(a3)
          move.l    #'N1_ ',2(a3)
nfsset0   move.w    d7,d1
          bsr       wmedit                        ; edit string
          moveq     #1,d2
          move.w    (a1),d4                       ; test length
          beq.s     nfsset00
          cmpi.w    #3,d4                         ; 3 is minimum
          bcs.s     nfsset0
          move.b    2(a1),d1                      ; get 1st char
          ori.b     #$20,d1                       ; lower case
          cmpi.b    #'n',d1                       ; is it 'n'
          bne.s     nfsset0                       ; repeat
          move.b    3(a1),d2                      ; get number
          sub.b     #$30,d2                       ; integer
          beq.s     nfsset0
          bmi.s     nfsset0
          cmpi.b    #9,d2                         ; bigger than 8 ?
          bcc.s     nfsset0
          cmpi.b    #'_',4(a1)                    ; underscore?
          bne.s     nfsset0
          ext.w     d2
          subq.w    #3,d4
          addq.w    #5,a1
nfsset00  move.l    mv_netptr(a6),a2              ; get driver address
          sub.w     #13,d7
          lsl.w     #4,d7                         ; get offset
          lea       $60(a2,d7.w),a2               ; item address
          trap      #0
          move.w    d2,(a2)+
          move.w    d4,(a2)+                      ; store length
          bra.s     nfsset2
nfsset1   move.b    (a1)+,(a2)+                   ; move string
nfsset2   dbf       d4,nfsset1
          andi.w    #$dfff,sr
          movem.l   (sp)+,d1/d2/d4/a0-a3
          bra       snets

*
*         Routine to set a device
*

DEVSET    movem.l   d1/d2/d4/a0-a3,-(sp)          ; store registers
          move.w    d7,d1                         ; item number
          sub.w     #17,d1                        ; calc buffer address
          mulu      #10,d1
          add.w     #mv_device+4,d1
          lea       (a6,d1.w),a3                  ; string address
devset0   move.w    d7,d1
          bsr       wmedit                        ; edit string
          move.w    (a1),d1                       ; check length
          cmpi.w    #3,d1
          bne.s     devset0
          bra.s     devset2
devset1   move.b    2(a1,d1.w),d2                 ; validation check
          cmpi.b    #'A',d2
          bcs.s     devset0
          cmpi.b    #$7b,d2
          bcc.s     devset0
          cmpi.b    #$5b,d2
          bcs.s     devset2
          cmpi.b    #'a',d2
          bcs.s     devset0
devset2   dbf       d1,devset1
          move.l    -4(a1),a2                     ; get driver address
          lea       $24(a2),a2                    ; address for item
          bra       nfsuse3

*
*         Routine to set STATION number
*

SETSTAT   movem.l   d1/d2/d4/a0-a3,-(sp)          ; store registers
setstat0  moveq     #10,d1                        ; item #10
          lea       mv_netstat(a6),a3             ; get string
          bsr       wmedit                        ; edit string
          tst.w     (a1)
          beq.s     setstat0
          move.b    2(a1),d4                      ; get ASCII number
          cmpi.b    #'1',d4                       ; validation check
          bcs.s     setstat0
          cmpi.b    #'9',d4
          bcc.s     setstat0
          sub.b     #$30,d4                       ; make integer
          moveq     #0,d0
          trap      #1                            ; get SysVars
          move.b    d4,sv_netnr(a0)               ; set station number
          movem.l   (sp)+,d1/d2/d4/a0-a3
          rts

*
*         Routine to set USER number
*

SETUSER   movem.l   d1/d2/d4/a0-a3,-(sp)          ; store registers
          moveq     #0,d4
setuser0  moveq     #11,d1                        ; item #11
          lea       mv_user(a6),a3                ; get string
          bsr       wmedit                        ; edit string
          move.w    (a1),d1
          beq.s     setuser0
          bra.s     setuser2
setuser1  move.b    2(a1,d1.w),d4                 ; get ASCII number
          cmpi.b    #'0',d4                       ; validation check
          bcs.s     setuser0
          cmpi.b    #$3a,d4
          bcc.s     setuser0
setuser2  dbf       d1,setuser1
          move.w    (a1)+,d1                      ; get length
          move.b    (a1)+,d4
          sub.b     #$30,d4                       ; make integer
          subq.w    #1,d1
          beq.s     setuser3
          mulu      #10,d4
          add.b     (a1),d4
          sub.b     #$30,d4
setuser3  cmpi.b    #16,d4
          bcc.s     setuser0
          moveq     #0,d0
          trap      #1                            ; get SysVars
          move.b    d4,sv_user(a0)
          movem.l   (sp)+,d1/d2/d4/a0-a3
          bra       suser

          end
