          include   flp1_qdos1_inc
          include   flp1_qdos2_inc
          include   flp1_qdos3_inc
          include   flp1_macro_inc
          include   flp1_wman_keys
          include   flp1_wman_wwork
          include   flp1_wman_wstatus
          include   flp1_qdos_pt

          section   MAIN

          xref      qtp_ink
          xdef      headings
          xdef      redraw

*
*         Subroutine to define sub-window
*
SUBWIN    moveq     #1,d1                         ; info window #1
          moveq     #0,d2
          move.b    qtp_ink,d2                    ; set ink
          jmp       wm.swinf(a2)                  ; set window def.


*
*         Subroutine to print headings
*
HEADINGS  movem.l   a0-a6,-(sp)                   ; save registers
          bsr       SUBWIN
          moveq     #-1,d3
          qdosio    sd.clear                      ; clear window
          lea       TEXTS,a4                      ; get text table
          move.w    (a4)+,d4
TEXTLOP   move.w    (a4)+,d2                      ; get y-position
          move.w    (a4)+,d1                      ; get x-position
          qdosio    sd.pos                        ; position cursor
          move.l    a4,a1                         ; text address
          move.w    (a1)+,d2
          qdosio    io.sstrg                      ; print text
          move.l    a1,d1
          addq.l    #1,d1
          andi.b    #$fe,d1
          move.l    d1,a4
          dbf       d4,TEXTLOP
          bra.s     CONTENTS

*
*         Subroutine to set position
*
SETPOS    move.w    (a5)+,d2                      ; y-position
          move.w    (a5)+,d1                      ; x-position
          qdosio    sd.pos
          rts

*
*         Subroutine to print a number
*
PRINTNUM  bsr       SETPOS                        ; set cursor
          moveq     #0,d2
          cmpi.w    #1000,d4                      ; fill with spaces
          bcc.s     DOPRINT
          addq.w    #1,d2
          cmpi.w    #100,d4
          bcc.s     DOPRINT
          addq.w    #1,d2
          cmpi.w    #10,d4
          bcc.s     DOPRINT
          addq.w    #1,d2
          bra.s     DOPRINT
PRLOOP    moveq     #' ',d1                       ; and print them
          qdosio    io.sbyte
DOPRINT   dbf       d2,PRLOOP
          move.w    d4,d1                         ; now print number
          move.w    ut.mint,a2
          jmp       (a2)
*
PRINTKB   tst.l     d4
          bpl.s     dokb
          moveq     #0,d4
dokb      lsr.l     #8,d4                         ; in KBytes
          lsr.w     #2,d4
          bsr       PRINTNUM
          lea       KBTEXT,a1                     ; print ' KB'
          vector    ut.mtext,a2
          qdosio    sd.clrrt
          rts
*
PRINTCNT  moveq     #0,d4                         ; clear counter
cntloop   cmpa.l    a3,a4
          beq       PRINTNUM
          move.l    (a4)+,d1                      ; valid entry?
          bmi       cntloop
          addq.w    #1,d4                         ; increment counter
          bra       cntloop

*
*         Subroutine to fill in contents
*
REDRAW    movem.l   a0-a6,-(sp)
          bsr       SUBWIN
CONTENTS  moveq     #-1,d3                        ; timeout
          lea       POSTAB,a5                     ; pointer to pos. table
          bsr       SETPOS
          move.l    a0,-(sp)
          qdosmt    mt.inf                        ; get QDOS version
          move.l    a0,a6                         ; store SysVars
          move.l    (sp),a0
          move.l    d2,(sp)
          move.l    sp,a1                         ; and print it
          moveq     #4,d2
          qdosio    io.sstrg
*
          bsr       SETPOS
          moveq     #$70,d0                       ; get Pointer version
          trap      #3
          move.l    d1,(sp)
          move.l    a1,a4
          move.l    sp,a1
          moveq     #4,d2
          qdosio    io.sstrg                      ; and print it
          addq.l    #4,sp
*
          bsr       SETPOS
          move.l    a4,a1                         ; print WMAN version
          moveq     #4,d2
          qdosio    io.sstrg
*
          move.l    sv_ramt(a6),d4                ; calc RAM size
          sub.l     #$20000,d4
          bsr       PRINTKB
*
          move.l    sv_basic(a6),d4               ; calc free RAM
          sub.l     sv_free(a6),d4
          sub.l     #1024,d4
          bsr       PRINTKB
*
          move.l    sv_trnsp(a6),d4               ; calc BASIC length
          sub.l     sv_basic(a6),d4
          bsr       PRINTKB
*
          move.l    sv_respr(a6),d4               ; calc JOBS length
          sub.l     sv_trnsp(a6),d4
          bsr       PRINTKB
*
          move.l    sv_free(a6),d4                ; calc HEAPS length
          sub.l     sv_cheap(a6),d4
          bsr       PRINTKB
*
          move.l    sv_ramt(a6),d4                ; calc RESPR area
          sub.l     sv_respr(a6),d4
          bsr       PRINTKB
*
          move.l    a0,-(sp)
          qdosmt    mt.free                       ; largest HEAP
          sub.l     #1024,d1
          move.l    d1,d4
          move.l    (sp)+,a0
          moveq     #-1,d3
          bsr       PRINTKB
*
          move.l    sv_jbbas(a6),a4               ; count JOBS
          move.l    sv_jbtop(a6),a3
          bsr       PRINTCNT
*
          move.l    sv_chbas(a6),a4               ; count CHANNELS
          move.l    sv_chtop(a6),a3
          bsr       PRINTCNT
*
          movem.l   (sp)+,a0-a6
          moveq     #-1,d3                        ; redraw selected items
          jmp       wm.ldraw(a2)

POSTAB    dc.w      0,25,1,25,2,25,4,27,5,27,6,27,7,27,8,27,9,27,10,27
          dc.w      12,9,13,9

KBTEXT    string    {' KB'}

TEXTS     dc.w      11
          dc.w      0,12
          string    {'QDOS Version'}
          dc.w      1,7
          string    {'Pointer Interface'}
          dc.w      2,10
          string    {'Window Manager'}
          dc.w      4,11
          string    {'total RAM size :'}
          dc.w      5,11
          string    {'free RAM space :'}
          dc.w      6,8
          string    {'occupied by BASIC :'}
          dc.w      7,8
          string    {'occupied by  JOBS :'}
          dc.w      8,8
          string    {'occupied by HEAPS :'}
          dc.w      9,2
          string    {'Resident Procedure Area :'}
          dc.w      10,2
          string    {'largest transient space :'}
          dc.w      12,14
          string    {'Jobs running'}
          dc.w      13,14
          string    {'Channels open'}

          dc.w      0

          end
